Codeforces--192.div2.D Biridian Forest bfs

来源:互联网 发布:移动端js框架有哪些 编辑:程序博客网 时间:2024/04/30 00:53
B. Biridian Forest
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

You're a mikemon breeder currently in the middle of your journey to become a mikemon master. Your current obstacle is go through the infamous Biridian Forest.

The forest

The Biridian Forest is a two-dimensional grid consisting of r rows and c columns. Each cell in Biridian Forest may contain a tree, or may be vacant. A vacant cell may be occupied by zero or more mikemon breeders (there may also be breeders other than you in the forest). Mikemon breeders (including you) cannot enter cells with trees. One of the cells is designated as the exit cell.

The initial grid, including your initial position, the exit cell, and the initial positions of all other breeders, will be given to you. Here's an example of such grid (from the first example):

Moves

Breeders (including you) may move in the forest. In a single move, breeders may perform one of the following actions:

  • Do nothing.
  • Move from the current cell to one of the four adjacent cells (two cells are adjacent if they share a side). Note that breeders cannot enter cells with trees.
  • If you are located on the exit cell, you may leave the forest. Only you can perform this move — all other mikemon breeders will never leave the forest by using this type of movement.

After each time you make a single move, each of the other breeders simultaneously make a single move (the choice of which move to make may be different for each of the breeders).

Mikemon battle

If you and t (t > 0) mikemon breeders are located on the same cell, exactly t mikemon battles will ensue that time (since you will be battling each of those t breeders once). After the battle, all of those t breeders will leave the forest to heal their respective mikemons.

Note that the moment you leave the forest, no more mikemon battles can ensue, even if another mikemon breeder move to the exit cell immediately after that. Also note that a battle only happens between you and another breeders — there will be no battle between two other breeders (there may be multiple breeders coexisting in a single cell).

Your goal

You would like to leave the forest. In order to do so, you have to make a sequence of moves, ending with a move of the final type. Before you make any move, however, you post this sequence on your personal virtual idol Blog. Then, you will follow this sequence of moves faithfully.

Goal of other breeders

Because you post the sequence in your Blog, the other breeders will all know your exact sequence of moves even before you make your first move. All of them will move in such way that will guarantee a mikemon battle with you, if possible. The breeders that couldn't battle you will do nothing.

Your task

Print the minimum number of mikemon battles that you must participate in, assuming that you pick the sequence of moves that minimize this number. Note that you are not required to minimize the number of moves you make.

Input

The first line consists of two integers: r and c (1 ≤ r, c ≤ 1000), denoting the number of rows and the number of columns in Biridian Forest. The next r rows will each depict a row of the map, where each character represents the content of a single cell:

  • 'T': A cell occupied by a tree.
  • 'S': An empty cell, and your starting position. There will be exactly one occurence of this in the map.
  • 'E': An empty cell, and where the exit is located. There will be exactly one occurence of this in the map.
  • A digit (0-9): A cell represented by a digit X means that the cell is empty and is occupied by X breeders (in particular, if X is zero, it means that the cell is not occupied by any breeder).

It is guaranteed that it will be possible for you to go from your starting position to the exit cell through a sequence of moves.

Output

A single line denoted the minimum possible number of mikemon battles that you have to participate in if you pick a strategy that minimize this number.

Sample test(s)
input
5 7000E0T3T0TT0T0010T0T02T0T0T00T0S000
output
3
input
1 4SE23
output
2
Note

The following picture illustrates the first example. The blue line denotes a possible sequence of moves that you should post in your blog:

The three breeders on the left side of the map will be able to battle you — the lone breeder can simply stay in his place until you come while the other two breeders can move to where the lone breeder is and stay there until you come. The three breeders on the right does not have a way to battle you, so they will stay in their place.

For the second example, you should post this sequence in your Blog:

Here's what happens. First, you move one cell to the right.

Then, the two breeders directly to the right of the exit will simultaneously move to the left. The other three breeder cannot battle you so they will do nothing.

You end up in the same cell with 2 breeders, so 2 mikemon battles are conducted. After those battles, all of your opponents leave the forest.

Finally, you make another move by leaving the forest.



题意:给出n*m的迷宫,T代表树不能走,0代表空地,1~9代表该方格上有的敌人数,从起点S出发到终点,求一路上必须得干掉的敌人的最小值。
思路:我们可以这样想,如果某个方格上的敌人能够与我相遇,那就相当于这些敌人到终点去等我,这是等价的,如果我到终点了有些敌人还没到终点那敌人就不可能追上我了,所以我走最短的路线就可以了,如果敌人走的步数小于我的步数就加上敌人数量。我用的一个s数组,bfs过程中遇到数字就把改点的步数存在s数组中,bfs完了以后遍历全图若s[i][j]<我的最小步数,就加上该点的敌人数。bfs采用反向的。
代码:
#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>#include <cmath>#include <string>#include <map>#include <stack>#include <vector>#include <set>#include <queue>#pragma comment (linker,"/STACK:102400000,102400000")#define maxn 1005#define MAXN 2005#define mod 1000000009#define INF 0x3f3f3f3f#define pi acos(-1.0)#define eps 1e-6typedef long long ll;using namespace std;struct Node{    int x,y,step;};int s[maxn][maxn];char mp[maxn][maxn];bool vis[maxn][maxn];int dir[4][2]={0,1,0,-1,-1,0,1,0};int n,m,sx,sy,ex,ey,ans,shortest;bool ISok(int x,int y){    if (x>=0&&x<n&&y>=0&&y<m&&!vis[x][y]&&mp[x][y]!='T')        return true;    return false;}void bfs(){    int flag=0;    queue<Node>Q;    memset(vis,false,sizeof(vis));    Node st,now;    while (!Q.empty())        Q.pop();    st.x=sx,st.y=sy,st.step=0;    vis[sx][sy]=true;    Q.push(st);    while (!Q.empty())    {        st=Q.front();        Q.pop();        if (st.x==ex&&st.y==ey)        {            shortest=st.step;            return ;        }        for (int i=0;i<4;i++)        {            int dx=st.x+dir[i][0];            int dy=st.y+dir[i][1];            if (ISok(dx,dy))            {                if (isdigit(mp[dx][dy])&&mp[dx][dy]!='0')                    s[dx][dy]=st.step+1;                now.x=dx;                now.y=dy;                now.step=st.step+1;                vis[dx][dy]=true;                Q.push(now);            }        }    }    return ;}int main(){    while (~scanf("%d%d",&n,&m))    {        ans=0;        memset(s,0,sizeof(s));        for (int i=0;i<n;i++)        {            scanf("%s",mp[i]);            for (int j=0;j<m;j++)            {                if (mp[i][j]=='E')                    sx=i,sy=j;                if (mp[i][j]=='S')                    ex=i,ey=j;            }        }        bfs();//        printf("shortest=%d\n",shortest);        for (int i=0;i<n;i++)            for (int j=0;j<m;j++)                if (s[i][j]&&s[i][j]<=shortest)                    ans+=(mp[i][j]-'0');        printf("%d\n",ans);    }    return 0;}/*5 7000E0T3T0TT0T0010T0T02T0T0T00T0S0001 4SE23*/


19 0
原创粉丝点击